﻿#region [ License information          ]
/* ************************************************************
 *
 * Copyright (c) Bjørn Bouet Smith, 2010, 2011
 *
 * This source code is subject to terms and conditions of 
 * Microsoft Public License (Ms-PL).
 * 
 * A copy of the license can be found in the license.txt
 * file at the root of this distribution. If you can not 
 * locate the License, please send an email to bjornsmith@gmail.com
 * 
 * By using this source code in any fashion, you are 
 * agreeing to be bound by the terms of the Microsoft 
 * Permissive License.
 *
 * You must not remove this notice, or any other, from this
 * software.
 *
 * ************************************************************/
#endregion

namespace Smith.AMC.Operations
{
    /// <summary>
    /// Represents the append operation, i.e.
    /// Add this data to the end of the existing data witht the same cache key.
    /// If there are no data to append to, then this operation will do nothing.
    /// </summary>
    public class AppendOperation : Operation
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AppendOperation"/> class.
        /// </summary>
        public AppendOperation()
            : base(OperationNames.Append)
        {
        }
    }
}
