﻿#region [ License information          ]
/* ************************************************************
 *
 * Copyright (c) Bjørn Bouet Smith, 2010, 2011
 *
 * This source code is subject to terms and conditions of 
 * Microsoft Public License (Ms-PL).
 * 
 * A copy of the license can be found in the license.txt
 * file at the root of this distribution. If you can not 
 * locate the License, please send an email to bjornsmith@gmail.com
 * 
 * By using this source code in any fashion, you are 
 * agreeing to be bound by the terms of the Microsoft 
 * Permissive License.
 *
 * You must not remove this notice, or any other, from this
 * software.
 *
 * ************************************************************/
#endregion

namespace Smith.AMC.Operations
{
    /// <summary>
    /// Represents the Delete operation, i.e. delete the data with this cache key.
    /// </summary>
    public class DeleteOperation : Operation
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DeleteOperation"/> class.
        /// </summary>
        public DeleteOperation()
            : base(OperationNames.Delete)
        {
            IsOneLine = true;
        }

        /// <summary>
        /// Returns a <see cref="System.String"/> that represents this instance.
        /// </summary>
        /// <returns>
        /// A <see cref="System.String"/> that represents this instance.
        /// </returns>
        public override string ToString()
        {
            return string.Concat(Name, Space, Key, "\r\n");
        }

    }
}
