﻿namespace Smith.AMC.Operations
{
    /// <summary>
    /// Contains the operation names
    /// </summary>
    public class OperationNames
    {
        /// <summary>
        /// The operation name for the gets command that will retrieve the CAS value.
        /// </summary>
        public const string Gets = "gets";

        /// <summary>
        /// The operation name for the delete command.
        /// </summary>
        public const string Delete = "delete";

        /// <summary>
        /// The operation name for the add command.
        /// </summary>
        public const string Add = "add";

        /// <summary>
        /// The operation name for the replace command.
        /// </summary>
        public const string Replace = "replace";

        /// <summary>
        /// The operation name for the append command.
        /// </summary>
        public const string Append = "append";

        /// <summary>
        /// The operation name for the prepend command.
        /// </summary>
        public const string Prepend = "prepend";

        /// <summary>
        /// The operation name for the Check And Set command
        /// </summary>
        public const string CheckAndSet = "cas";

        /// <summary>
        /// The operation name for the increment command
        /// </summary>
        public const string Increment = "incr";

        /// <summary>
        /// The operation name for the increment command
        /// </summary>
        public const string Decrement = "decr";

        /// <summary>
        /// The operation name for the get command
        /// </summary>
        public const string Get = "get";

        /// <summary>
        /// The operation name for the MultiGet command
        /// </summary>
        public const string MultiGet = "gets";

        /// <summary>
        /// The operation name for the set command
        /// </summary>
        public const string Set = "set";

        /// <summary>
        /// The operation name for the flush all command.
        /// </summary>
        public const string FlushAll = "flush_all";

        /// <summary>
        /// The operation name for the stats command.
        /// </summary>
        public const string Stats = "stats";
    }
}
