﻿#region [ License information          ]
/* ************************************************************
 *
 * Copyright (c) Bjørn Bouet Smith, 2010, 2011
 *
 * This source code is subject to terms and conditions of 
 * Microsoft Public License (Ms-PL).
 * 
 * A copy of the license can be found in the license.txt
 * file at the root of this distribution. If you can not 
 * locate the License, please send an email to bjornsmith@gmail.com
 * 
 * By using this source code in any fashion, you are 
 * agreeing to be bound by the terms of the Microsoft 
 * Permissive License.
 *
 * You must not remove this notice, or any other, from this
 * software.
 *
 * ************************************************************/
#endregion

namespace Smith.AMC.Operations
{
    /// <summary>
    /// Represents the prepend operation, i.e. add this data before the data in the cache, the opposite of append.
    /// </summary>
    public class PrependOperation : Operation
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PrependOperation"/> class.
        /// </summary>
        public PrependOperation()
            : base(OperationNames.Prepend)
        {
        }
    }
}
