﻿#region [ License information          ]
/* ************************************************************
 *
 * Copyright (c) Bjørn Bouet Smith, 2010, 2011
 *
 * This source code is subject to terms and conditions of 
 * Microsoft Public License (Ms-PL).
 * 
 * A copy of the license can be found in the license.txt
 * file at the root of this distribution. If you can not 
 * locate the License, please send an email to bjornsmith@gmail.com
 * 
 * By using this source code in any fashion, you are 
 * agreeing to be bound by the terms of the Microsoft 
 * Permissive License.
 *
 * You must not remove this notice, or any other, from this
 * software.
 *
 * ************************************************************/
#endregion

namespace Smith.AMC.Operations
{
    /// <summary>
    /// Represents the Set operation, i.e. a unconditional set. Overwrite any existing data with the same key, if data does not exist.
    /// Add it.
    /// </summary>
    public class SetOperation : Operation
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SetOperation"/> class.
        /// </summary>
        public SetOperation()
            : base(OperationNames.Set)
        {
        }
    }
}
